'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _red = require('@material-ui/core/colors/red');

var _red2 = _interopRequireDefault(_red);

var _FormLabel = require('@material-ui/core/FormLabel');

var _FormLabel2 = _interopRequireDefault(_FormLabel);

var _FormGroup = require('@material-ui/core/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

var _CloudUpload = require('@material-ui/icons/CloudUpload');

var _CloudUpload2 = _interopRequireDefault(_CloudUpload);

var _PhotoLibrary = require('@material-ui/icons/PhotoLibrary');

var _PhotoLibrary2 = _interopRequireDefault(_PhotoLibrary);

var _Delete = require('@material-ui/icons/Delete');

var _Delete2 = _interopRequireDefault(_Delete);

var _CircularProgress = require('@material-ui/core/CircularProgress');

var _CircularProgress2 = _interopRequireDefault(_CircularProgress);

var _reactDropzone = require('react-dropzone');

var _reactDropzone2 = _interopRequireDefault(_reactDropzone);

var _FileGrid = require('../../components/FileGrid/FileGrid');

var _FileGrid2 = _interopRequireDefault(_FileGrid);

var _arrayUtils = require('../../utils/arrayUtils');

var _download = require('../../utils/download');

var _download2 = _interopRequireDefault(_download);

var _upload = require('../../utils/upload');

var _upload2 = _interopRequireDefault(_upload);

var _PhotoGalleryModal = require('../../components/FileGrid/PhotoGalleryModal');

var _PhotoGalleryModal2 = _interopRequireDefault(_PhotoGalleryModal);

var _FileGridItem = require('../../components/FileGrid/FileGridItem');

var _FileGridItem2 = _interopRequireDefault(_FileGridItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var convertFilesUploadToFormDinamicoFiles = function convertFilesUploadToFormDinamicoFiles(files) {
    return files.map(function (file) {
        file.length = file.size;
        file.link = file.preview;

        return file;
    });
};

var styles = function styles(theme) {
    return {
        actions: {
            display: 'flex',
            alignItems: 'center',
            marginTop: '10px'
        },
        button: {
            margin: theme.spacing.unit,
            '&:first-child': {
                marginLeft: 0
            }
        },
        rightIcon: {
            marginLeft: theme.spacing.unit
        }
    };
};

var MultipleUploadWidget = function (_Component) {
    _inherits(MultipleUploadWidget, _Component);

    function MultipleUploadWidget() {
        var _temp, _this, _ret;

        _classCallCheck(this, MultipleUploadWidget);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
            accepted: Array.isArray(_this.props.formData) ? [].concat(_this.props.formData) : [],
            loading: false,
            error: false,
            openPhotoGallery: false
        }, _this.handleDeleteClick = function (file, index) {
            var onChange = _this.props.onChange;


            _this.setState(function (state) {
                var array = (0, _arrayUtils.removeItemArray)(state.accepted, index);

                onChange(array);
                return { accepted: array };
            });
        }, _this.handleUploadFiles = function (accepted) {
            var onChange = _this.props.onChange;

            var config = _this.getUploadConfig();
            var originalAcceptedFiles = [].concat(_this.state.accepted);

            _this.setState(function () {
                return {
                    accepted: [].concat(originalAcceptedFiles, convertFilesUploadToFormDinamicoFiles(accepted)),
                    loading: true
                };
            });

            var promises = accepted.map(function (acceptedFile) {
                return (0, _upload2.default)(config, acceptedFile);
            });

            Promise.all(promises).then(function (values) {
                var allFiles = [].concat(originalAcceptedFiles, values).filter(function (elem, pos, arr) {
                    return arr.indexOf(elem) === pos;
                });

                _this.setState(function () {
                    return {
                        accepted: allFiles,
                        loading: false,
                        error: false
                    };
                });

                onChange(allFiles);
            }, function (error) {
                console.error('Erro ao fazer o upload', error);
                _this.setState({
                    error: error,
                    accepted: originalAcceptedFiles,
                    loading: false
                });
            });
        }, _this.handleOpenPhotoGallery = function () {
            _this.setState({ openPhotoGallery: true });
        }, _this.handleCancelPhotoGallery = function () {
            _this.setState({ openPhotoGallery: false });
        }, _this.handleConfirmPhotoGallery = function (selectedsPhotos) {
            var onChange = _this.props.onChange;


            _this.setState(function (state) {
                var allFiles = [].concat(state.accepted, selectedsPhotos).filter(function (elem, pos, arr) {
                    return arr.indexOf(elem) === pos;
                });

                //TODO: verificar se vai funcionar
                onChange && onChange(selectedsPhotos);

                return {
                    accepted: allFiles,
                    openPhotoGallery: false
                };
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    MultipleUploadWidget.prototype.handleDownloadClick = function handleDownloadClick() {
        var uiSchema = this.props.uiSchema;
        var headers = uiSchema['ui:options'].headers;


        return function (file) {
            return (0, _download2.default)(file, headers);
        };
    };

    MultipleUploadWidget.prototype.getUploadConfig = function getUploadConfig() {
        var uiSchema = this.props.uiSchema;


        return uiSchema['ui:options'].upload;
    };

    MultipleUploadWidget.prototype.renderFileList = function renderFileList() {
        var _this2 = this;

        var accepted = this.state.accepted;


        return _react2.default.createElement(
            'div',
            { style: { marginTop: '15px' } },
            _react2.default.createElement(_FileGrid2.default, {
                files: accepted,
                render: function render(file, index) {
                    return _react2.default.createElement(_FileGridItem2.default, {
                        key: index,
                        index: index,
                        file: file,
                        onFileClick: _this2.handleDownloadClick,
                        onActionClick: _this2.handleDeleteClick,
                        actionIcon: _react2.default.createElement(_Delete2.default, { style: { color: '#fff' } })
                    });
                }
            })
        );
    };

    MultipleUploadWidget.prototype.renderError = function renderError() {
        return _react2.default.createElement(
            'p',
            { style: { margin: '15px 0 0' } },
            _react2.default.createElement(
                _Typography2.default,
                {
                    component: 'span',
                    style: { color: _red2.default['A400'] }
                },
                'Ocorreu um erro ao fazer o upload'
            )
        );
    };

    MultipleUploadWidget.prototype.renderUpload = function renderUpload() {
        var _this3 = this;

        var _state = this.state,
            loading = _state.loading,
            openPhotoGallery = _state.openPhotoGallery;
        var _props = this.props,
            classes = _props.classes,
            schema = _props.schema,
            uiSchema = _props.uiSchema,
            formData = _props.formData;

        var gallery = uiSchema['ui:options'].customProps || [];

        return _react2.default.createElement(
            'div',
            { className: classes.actions },
            Boolean(gallery.length) && _react2.default.createElement(
                _Button2.default,
                {
                    className: classes.button,
                    variant: 'raised',
                    color: 'default',
                    onClick: this.handleOpenPhotoGallery,
                    disabled: loading
                },
                'Galeria',
                _react2.default.createElement(_PhotoLibrary2.default, { className: classes.rightIcon })
            ),
            _react2.default.createElement(
                _Button2.default,
                {
                    variant: 'raised',
                    color: 'default',
                    onClick: function onClick() {
                        _this3.dropzoneRef.open();
                    },
                    disabled: schema.disabled || loading
                },
                'Upload',
                _react2.default.createElement(_CloudUpload2.default, { className: classes.rightIcon })
            ),
            loading && _react2.default.createElement(_CircularProgress2.default, { className: classes.progress }),
            _react2.default.createElement(_reactDropzone2.default, {
                ref: function ref(node) {
                    _this3.dropzoneRef = node;
                },
                onDrop: this.handleUploadFiles,
                style: { visibility: 'hidden' }
            }),
            openPhotoGallery && _react2.default.createElement(_PhotoGalleryModal2.default, {
                open: openPhotoGallery,
                selecteds: formData,
                gallery: gallery,
                onCancel: this.handleCancelPhotoGallery,
                onConfirm: this.handleConfirmPhotoGallery
            })
        );
    };

    MultipleUploadWidget.prototype.render = function render() {
        var schema = this.props.schema;
        var _state2 = this.state,
            error = _state2.error,
            accepted = _state2.accepted;


        return _react2.default.createElement(
            'section',
            null,
            _react2.default.createElement(
                _FormControl2.default,
                { component: 'fieldset' },
                _react2.default.createElement(
                    _FormLabel2.default,
                    { component: 'legend' },
                    schema.title + (schema.required ? ' *' : '')
                )
            ),
            _react2.default.createElement(
                _FormGroup2.default,
                null,
                this.renderUpload(),
                error && this.renderError(),
                Boolean(accepted.length) && this.renderFileList()
            )
        );
    };

    return MultipleUploadWidget;
}(_react.Component);

MultipleUploadWidget.defaultProps = {
    formData: []
};

exports.default = (0, _styles.withStyles)(styles)(MultipleUploadWidget);
module.exports = exports['default'];